codon.bias <-
structure(function (nc = 16, only.main=FALSE) 
{
	# Note: new.codon.bias; see: 12_CodonBias and 14_NewCodonInfo
    temp.fun <- function(z) {
        temp.c <- names(z)
        temp.nc <- length(z)
        temp.bases <- c("A", "T", "G", "C")
        t.res <- matrix(0, nrow = 3, ncol = 4, dimnames = list(c("F", 
            "S", "T"), temp.bases))
        t.fb <- substring(temp.c, 1, 1)
        t.sb <- substring(temp.c, 2, 2)
        t.tb <- substring(temp.c, 3, 3)
        for (i in 1:4) {
            t.res[1, i] <- sum(z[c(1:temp.nc)[t.fb == temp.bases[i]]])
            t.res[2, i] <- sum(z[c(1:temp.nc)[t.sb == temp.bases[i]]])
            t.res[3, i] <- sum(z[c(1:temp.nc)[t.tb == temp.bases[i]]])
        }
        temp.4.H.all.bases <- apply(t.res, 2, sum)
        temp.4.H.all.bases <- temp.4.H.all.bases/sum(temp.4.H.all.bases)
        H.all <- est.H(temp.4.H.all.bases)[2]
        temp.rf <- t.res/sum(z)
        temp.r <- c(H.all, est.H(temp.rf[1, ])[2], est.H(temp.rf[2, 
            ])[2], est.H(temp.rf[3, ])[2])
        names(temp.r) <- c("H.all", "Hfb", "Hsb", "Htb")
        temp.r
    }
    temp.gc <- gen.code.n.cod[gen.code.n.cod$n.cod >= 2, ]
    aa.list <- vector("list", 19)
    names(aa.list) <- temp.gc$aa
    for (i in 1:19) {
        aa.list[[i]] <- rep(NA, temp.gc$n.cod[i])
        names(aa.list[[i]]) <- strsplit(temp.gc$codons[i], split = ", ", 
            fixed = TRUE)[[1]]
    }
    lib.name <- attributes(codon.freq)$dimnames[[2]][nc]
    cod.freq <- codon.freq[, nc]
    temp.cod <- names(cod.freq)
    for (i in 1:19) {
        for (j in 1:temp.gc$n.cod[i]) {
            temp.num <- c(1:64)[temp.cod == names(aa.list[[i]][j])]
            aa.list[[i]][j] <- cod.freq[temp.num]
        }
    }
    fre.aa <- rep(NA, 19)
    for (i in 1:19) {
        fre.aa[i] <- sum(aa.list[[i]])
    }

    cod.rel.fre <- aa.list
    for (i in 1:19) {
        cod.rel.fre[[i]] <- cod.rel.fre[[i]]/sum(cod.rel.fre[[i]])
    }
    H.per.aa <- vector("list", 19)
    names(H.per.aa) <- temp.gc$aa
    for (i in 1:19) {
        H.per.aa[[i]] <- temp.fun(aa.list[[i]])
    }
    res.H.pb <- data.frame(H.all = rep(NA, 19), Hfb = NA, Hsb = NA, 
        Htb = NA)
    for (i in 1:19) {
        res.H.pb[i, 1:4] <- H.per.aa[[i]]
    }
    H.per.aa <- rep(NA, 19)
    # New: ENC = Effective Number of Codons est.H(cod.rel.fre[[i]])[2]
    ENC <- rep(NA, 19)
    for (i in 1:19) {
        H.per.aa[i] <- est.H(cod.rel.fre[[i]])[2]
        ENC[i] <- est.H(cod.rel.fre[[i]])[3]
    }
    temp.pr <- cbind(libray = rep(lib.name, 19), data.frame(fre.aa = fre.aa), 
        temp.gc[, 1:2], H.per.aa = H.per.aa, res.H.pb)
    attributes(temp.pr)$row.names <- c(1:19)
    temp.pr$H.max.aa <- log2(temp.pr$n.cod)
# OLD definition of CodBias.aa (deprecated)
#    temp.pr$CodBias.aa <- 1 - ((temp.pr$H.max.aa - temp.pr$H.per.aa)/temp.pr$H.max.aa)
# Need ENC and temp.pr$n.cod only
# New definition of temp.pr$CodBias.aa
	temp.pr$ENC <- ENC
	temp.pr$CodBias.aa <- (temp.pr$n.cod - ENC)/(temp.pr$n.cod - 1)
    
    if(only.main == TRUE){
    		# Will give only: aa, n.cod, H.per.aa, ENC, CodBias.aa
    		temp.om <- temp.pr[,c(3:5, 11,12)]
    		comment(temp.om) <- lib.name
    		return(temp.om)
    } else {
    		comment(temp.pr) <- lib.name
    		return(temp.pr)
    }
}, comment = c("Input: nc (Number of Column of codon.freq)", 
"Output: a data.frame with 19 rows (one for each amino acid coded by at least two codons) and 12 columns with information properties, including CodBias.aa; see help."
))
