prop.bases <-
structure(function(nc=16, print.data = FALSE, by.row=FALSE){
	# Calculate the properties by base within codon.
	# x are the frequencies
	x <- codons2bases(nc=nc, print.data = print.data)

	# input MUST be the result of codons2bases() !!!
	lib.name <- comment(x)

	if(is.null(lib.name)) stop("x must be the result of function codons2bases!")
	res <- data.frame(x/apply(x, 1, sum)) # The relative frequencies

	# Add variables: Hest (2), ENB (3) , Info (4),  V.est (5)
	res$Hest <- NA
	res$ENB <- NA
	res$Info <- NA
	res$V.est <- NA

	for(i in 1:4){
		res[i, 5:8] <- est.H(res[i, 1:4])[2:5]
	}
	comment(res) <- lib.name

	if(by.row == TRUE){ # Gives only one row with everything!
		res <- data.frame(data=lib.name, matrix(unlist(res[,5:8]), nrow=1, ncol=16, dimnames=list(c(1), paste(rep(c("H", "ENB", "Info", "V"), each=4), rep(c("F", "S", "T", "To"), 4), sep="."))))
	}
	res
}, comment = c("Parameters: nc - Number of Column; print.data (logic); by.row (logic)", 
"Output: If by.row=F, a data.frame with relative frequencies of each base in the first (F), second (S) and third (T) codon positions as well as in Total of all three codon positions, also columns with information properties derived from that matrix. If by.row=T same information in a single row."
))
